#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <stdio.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#include <util/delay.h>
#include <util/atomic.h>

#include <inttypes.h>

#include "avrupdate.h"
#include "usbn2mc.h"
#include "usbdescriptor.h"

//#include "usbn2mc/fifo.h"

#include "led.h"

#include "uart.h"
#include "debug.h"

#define UNKNOWN_COMMAND	0x00
#define GET_SPI_DATA	0xC1
#define SET_SPI_DATA	0xC2
#define TRANSFER_SPI_DATA	0xc3



/*uint8_t buffer[128+64];
volatile uint8_t count = 0;
volatile uint8_t pos = 0;*/

/*void CommandAnswer(uint8_t length);
void QueueFirstAnswerByte(uint8_t);
void QueueAnswerByte(uint8_t);
void QueueLastAnswerByte(uint8_t);
*/
extern uint8_t USBNGetRxStatus(uint8_t ep);

volatile struct usbprog_t {
  char lastcmd;
  int longpackage;
  int cmdpackage;
  int datatogl;
  unsigned int sck_duration;
  uint16_t fill_pos;
  uint16_t send_pos;
  int avrstudio;
  int reset_pol;
  uint8_t ready_to_transmit: 1;
  uint8_t complete:     1;
} usbprog;

#define _BUF_LEN     64
#define _TMP_OFFSET  32
volatile unsigned char answer[_BUF_LEN];

extern void Endpoint_ClearIN(uint8_t ep);
extern void Endpoint_ClearOUT(uint8_t ep);
extern uint8_t Endpoint_IsINReady(uint8_t ep);

char spi_transfer_data(char send);

ISR(INT0_vect)
{
  USBNInterrupt();
}

/* id need for live update of firmware */

void USBNDecodeVendorRequest(DeviceRequest *req)
{
  switch(req->bRequest)
  {
    case STARTAVRUPDATE:
      avrupdate_start();
    break;
  }
}

void
USBNDecodeClassRequest (DeviceRequest * req/*, EPInfo * ep*/)
{
	//USBNWrite(EPC0,USBNRead(EPC0)|STALL);
}

void USBToglAndSend(void)
{
  uint8_t sreg = SREG;
  cli();
  if(usbprog.datatogl == 1) {
    USBNWrite(TXC1, TX_LAST+TX_EN+TX_TOGL);
    usbprog.datatogl = 0;
  } else {
    USBNWrite(TXC1, TX_LAST+TX_EN);
    usbprog.datatogl = 1;
  }
  SREG = sreg;
}

/*void SendCompleteAnswer(void)
{
  uint8_t size, sreg = SREG;
  cli();

  if(usbprog.send_pos >= usbprog.fill_pos) {
    SREG = sreg;
    return;
  }

  USBNWrite(TXC1, FLUSH);
  if (usbprog.fill_pos > usbprog.send_pos + 64)
  {
    size = 64;
  }
  else
  {
    size = usbprog.fill_pos - usbprog.send_pos;
  }
  USBNWriteBlock(TXD1, (unsigned char*)answer + usbprog.send_pos, size, 0);
  usbprog.send_pos += size;

  USBToglAndSend();

  SREG = sreg;
}

void QueueAnswerByte(uint8_t data)
{
  uint8_t sreg;

  sreg = SREG;
  cli();

  answer[usbprog.fill_pos++] = data;
  if (usbprog.ready_to_transmit && usbprog.fill_pos >= usbprog.send_pos + 64) {
    CommandAnswer(64);
  }

  SREG = sreg;
}

void QueueFirstAnswerByte(uint8_t data)
{
  uint8_t sreg;

  sreg = SREG;
  cli();

  usbprog.ready_to_transmit = 1;
  usbprog.complete = 0;
  usbprog.fill_pos = 0;
  usbprog.send_pos = 0;

  SREG = sreg;

  QueueAnswerByte(data);

}

void QueueLastAnswerByte(uint8_t data)
{
  uint8_t sreg;
  uint16_t size;

  QueueAnswerByte(data);

  sreg = SREG;
  cli();

  usbprog.complete = 1;
  if (usbprog.ready_to_transmit) {
    size = usbprog.fill_pos - usbprog.send_pos;
    CommandAnswer(size > 64 ? 64 : size);
  }

  SREG = sreg;
}*/

/*void CommandAnswer(uint8_t length)
{
  uint8_t sreg = SREG;
  cli();
  USBNWrite(TXC1, FLUSH);
  USBNWriteBlock(TXD1, (uint8_t*)answer + usbprog.send_pos, length, 0);
  USBToglAndSend(); // control togl bit
  usbprog.send_pos += length;
  usbprog.ready_to_transmit = 0;
  SREG = sreg;
}*/

void RequestTransmit(void) {
/*	LED_off();
	LED_toggle();
	_delay_ms(10);
	LED_toggle();
	_delay_ms(10);
	LED_toggle();
	_delay_ms(10);
	LED_off();
*/
	tx_info[1].Buffer = (uint8_t*)answer;
	tx_info[1].BufferIndex = 0;
	tx_info[1].BufferSize = 2;
}

/* central command parser */
void Commands(void/*char * buf*/) {
	if (!USBNGetRxStatus(1))
		return;

	  ATOMIC_BLOCK(ATOMIC_RESTORESTATE) {

	  uint8_t buf[64];
	  uint16_t numbytes = USBNGetRxData(1, buf, 64);
	  /*rx_info[1].Buffer = buf;
	  rx_info[1].BufferIndex = 0;
	  rx_info[1].BufferSize = 64;
	  _USBNReceive(1);
	  Endpoint_ClearOUT(1);*/
	  //USBNWrite(TXC1, 0x00);

	  //USBNWrite(TXC1, FLUSH);

	//ATOMIC_BLOCK(ATOMIC_RESTORESTATE) {
/*
		uint8_t buf[64];
		uint8_t size;
		size = USBNGetRxData(1, buf, 64);*/

  //usbprog.datatogl =0 ;

  /*LED_on();
  /_delay_ms(100);*/

  switch(buf[0]) {
    case GET_SPI_DATA:
    	LED_toggle();

      //answer[1] = spi_transfer_data(0xff);
    	answer[0] = GET_SPI_DATA;
    	answer[1] = 0xff;
    	/*QueueFirstAnswerByte(GET_SPI_DATA);
    	QueueLastAnswerByte(0xff);*/
    	break;
    case SET_SPI_DATA:
    	LED_toggle();

    	//spi_transfer_data(buf[1]);
    	answer[0] = SET_SPI_DATA;
    	answer[1] = 0x00;

    	/*QueueFirstAnswerByte(SET_SPI_DATA);
    	QueueLastAnswerByte(0x00);*/
    	break;

    case TRANSFER_SPI_DATA:
    	LED_toggle();

    	//answer[1] = spi_transfer_data(buf[1]);
    	/*QueueFirstAnswerByte(TRANSFER_SPI_DATA);
    	QueueLastAnswerByte((buf[1]>>1));*/

    	answer[0] = TRANSFER_SPI_DATA;
    	answer[1] = (buf[1]>>1);
    	break;

    default:
    	LED_toggle();

    	// unkown command
    	/*QueueFirstAnswerByte(UNKOWN_COMMAND);
    	QueueLastAnswerByte(0xaa);*/
    	answer[0] = UNKNOWN_COMMAND;
    	answer[1] = 0xaa;
    	break;
  }

  //RequestTransmit();
	  }
  /*USBNWrite(TXC0,FLUSH);
  USBNWrite(RXC0,RX_EN);	//re-enable the receiver*/


/*  LED_off();
  _delay_ms(100);*/

/*  	  SREG = sreg;
	}*/

}

char spi_transfer_data(char send) {
	SPCR |= (1<<MSTR); // master mode

	SPDR = send; // start transfer
	while (!(SPSR & (1<<SPIF))); // wait until done

	if ((SPCR & (1<<MSTR))==0) // are we still master
			return 0xff; // i was interrupted, data invalid

	return SPDR;
}

/*void RequestTransmit(void)
{
    uint8_t sreg;
    uint16_t size;

    sreg = SREG;
    cli();

    usbprog.ready_to_transmit = 1;
    size = usbprog.fill_pos - usbprog.send_pos;
    if (size >= 64) {
      CommandAnswer(64);
    } else if (usbprog.complete && size) {
      CommandAnswer(size);
    }

    SREG = sreg;
}*/

/*volatile uint32_t ticker;

void initTimer(void)
{
    uint8_t sreg = SREG;
    cli();
#if defined(__AVR_ATmega32__)
    TCCR0 = 0;

    ticker = 0;

    TCNT0 = 0;
    OCR0 = 250-1;
    TCCR0 = (1<<WGM01)|(1<<CS01)|(1<<CS00); // ctc mode, CLK/64
    TIMSK &= ~(1<<TOIE0);
    TIMSK |= (1<<OCIE0);
#elif defined(__AVR_ATmega644__)
    TCCR0A = 0;
    TCCR0B = 0;

    ticker = 0;

    TCNT0 = 0;
    OCR0A = 199;
    OCR0B = 0;
    TCCR0A = (1<<WGM01); // ctc mode
    TCCR0B = (1<<CS01);

    TIMSK0 &= ~((1<<TOIE0)|(1<<OCIE0B));;
    TIMSK0 |= (1<<OCIE0A);
#else
#endif
    SREG = sreg;
}

uint32_t getTicker(void)
{
    uint32_t result;
    uint8_t sreg = SREG;
    cli();
    result = ticker;
    SREG = sreg;
    return result;
}

#if defined( __AVR_ATmega32__)
ISR(TIMER0_COMP_vect)
#elif defined(__AVR_ATmega644__)
ISR(TIMER0_COMPA_vect)
#else
#endif
{
    ticker++;
}*/

int main(void) {

    LED_init();
	PORTB |= (1<<PIN4); DDRB |= (1<<PIN4); PORTB &= ~(1<<PIN4);
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR1);

#ifdef DEBUG
  //initTimer();
  initUart();
  initDebug();
#endif

	USBNInitMC(); // Setup MC Registers for USBN

    USBNInit((struct usb_device_descriptor*)&usbserialDevice,
             (struct usb_configuration_descriptor_tab*)&usbserialConfTab,
             (struct usb_wstring_descriptor_tab*)&StringTab);

    usbprog.send_pos = 0;
    usbprog.datatogl = 0;   // 1MHz

    //USBNAddInEndpointCallback(1, RequestTransmit);
    USBNAddOutEndpointCallback(1, Commands);

    sei();

    // start usb chip
    USBNStart();



    while(1) {
    	ATOMIC_BLOCK(ATOMIC_RESTORESTATE) {
			if (tx_info[1].BufferIndex == 0 && tx_info[1].BufferSize > 0 && Endpoint_IsINReady(1)) {
				USBNWrite(tx_ctrl[1].txc,FLUSH);
				USBNWriteBlock(tx_ctrl[1].txd, tx_info[1].Buffer + tx_info[1].BufferIndex, tx_info[1].BufferSize, 0);
				//_USBNTransmit(1);
				USBToglAndSend();
				//
			}
    	}
    	_delay_ms(100);
    }
}



